/[gentoo-x86]/eclass/vdr-plugin.eclass
Gentoo

Diff of /eclass/vdr-plugin.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.11 Revision 1.49
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2005 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.11 2005/12/10 10:59:59 zzam Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.49 2007/08/16 17:59:21 zzam Exp $
4# 4#
5# Author: 5# Author:
6# Matthias Schwarzott <zzam@gentoo.org> 6# Matthias Schwarzott <zzam@gentoo.org>
7# Joerg Bornkessel <hd_brummy@gentoo.org>
7 8
8# vdr-plugin.eclass 9# vdr-plugin.eclass
9# 10#
10# eclass to create ebuilds for vdr plugins 11# eclass to create ebuilds for vdr plugins
11# 12#
22# KEYWORDS="~x86" 23# KEYWORDS="~x86"
23# DEPEND=">=media-video/vdr-1.3.27" 24# DEPEND=">=media-video/vdr-1.3.27"
24# 25#
25# 26#
26 27
27# There are some special files in ${FILESDIR} which get installed when 28# Installation of a config file for the plugin
28# they exist: 29#
30# If ${VDR_CONFD_FILE} is set install this file
31# else install ${FILESDIR}/confd if it exists.
29 32
30# ${FILESDIR}/confd-${PV} or ${FILESDIR}/confd:
31# The first matching is installed under /etc/conf.d/vdr.${VDRPLUGIN} 33# Gets installed as /etc/conf.d/vdr.${VDRPLUGIN}.
32# (in example vdr-femon this would be /etc/conf.d/vdr.femon) 34# For the plugin vdr-femon this would be /etc/conf.d/vdr.femon
33#
34# Everything put in variable _EXTRAOPTS is appended to the command line of
35# the plugin.
36 35
37 36
38# ${FILESDIR}/rc-addon-${PV}.sh or ${FILESDIR}/rc-addon.sh: 37# Installation of an rc-addon file for the plugin
39# The first matching is installed under /usr/lib/vdr/rcscript/plugin-${VDRPLUGIN}.sh 38#
39# If ${VDR_RCADDON_FILE} is set install this file
40# else install ${FILESDIR}/rc-addon.sh if it exists.
41#
42# Gets installed under ${VDR_RC_DIR}/plugin-${VDRPLUGIN}.sh
40# (in example vdr-femon this would be /usr/lib/vdr/rcscript/plugin-femon.sh) 43# (in example vdr-femon this would be /usr/share/vdr/rcscript/plugin-femon.sh)
41# 44#
42# This file is sourced by the startscript when plugin is activated in /etc/conf.d/vdr 45# This file is sourced by the startscript when plugin is activated in /etc/conf.d/vdr
43# It could be used for special startup actions for this plugins, or to create the 46# It could be used for special startup actions for this plugins, or to create the
44# plugin command line options from a nicer version of a conf.d file. 47# plugin command line options from a nicer version of a conf.d file.
45 48
49# HowTo use own local patches; Example
50#
51# Add to your /etc/make.conf:
52# VDR_LOCAL_PATCHES_DIR="/usr/local/patch"
53#
54# Add two DIR's in your local patch dir, ${PN}/${PV},
55# e.g for vdr-burn-0.1.0 should be:
56# /usr/local/patch/vdr-burn/0.1.0/
57#
58# all patches which ending on diff or patch in this DIR will automatically applied
59#
60
46inherit eutils flag-o-matic 61inherit base multilib eutils flag-o-matic
62
63IUSE=""
47 64
48# Name of the plugin stripped from all vdrplugin-, vdr- and -cvs pre- and postfixes 65# Name of the plugin stripped from all vdrplugin-, vdr- and -cvs pre- and postfixes
49VDRPLUGIN="${PN/#vdrplugin-/}" 66VDRPLUGIN="${PN/#vdrplugin-/}"
50VDRPLUGIN="${VDRPLUGIN/#vdr-/}" 67VDRPLUGIN="${VDRPLUGIN/#vdr-/}"
51VDRPLUGIN="${VDRPLUGIN/%-cvs/}" 68VDRPLUGIN="${VDRPLUGIN/%-cvs/}"
54 71
55# works in most cases 72# works in most cases
56S="${WORKDIR}/${VDRPLUGIN}-${PV}" 73S="${WORKDIR}/${VDRPLUGIN}-${PV}"
57 74
58# depend on headers for DVB-driver 75# depend on headers for DVB-driver
59RDEPEND="" 76RDEPEND=">=media-tv/gentoo-vdr-scripts-0.3.4-r1"
60DEPEND="media-tv/linuxtv-dvb-headers" 77DEPEND="media-tv/linuxtv-dvb-headers"
61
62# Where should the plugins live in the filesystem
63VDR_PLUGIN_DIR="/usr/lib/vdr/plugins"
64
65VDR_RC_DIR="/usr/lib/vdr/rcscript"
66
67# Pathes to includes
68VDR_INCLUDE_DIR="/usr/include"
69DVB_INCLUDE_DIR="/usr/include"
70 78
71 79
72# this code is from linux-mod.eclass 80# this code is from linux-mod.eclass
73update_vdrplugindb() { 81update_vdrplugindb() {
74 local VDRPLUGINDB_DIR=${ROOT}/var/lib/vdrplugin-rebuild/ 82 local VDRPLUGINDB_DIR=${ROOT}/var/lib/vdrplugin-rebuild/
90 einfo "Removing ${CATEGORY}/${PN}-${PVR} from vdrplugindb." 98 einfo "Removing ${CATEGORY}/${PN}-${PVR} from vdrplugindb."
91 sed -ie "/.*${CATEGORY}\/${P}.*/d" ${VDRPLUGINDB_DIR}/vdrplugindb 99 sed -ie "/.*${CATEGORY}\/${P}.*/d" ${VDRPLUGINDB_DIR}/vdrplugindb
92 fi 100 fi
93} 101}
94 102
103# New method of storing plugindb
104# Called from src_install
105# file maintained by normal portage-methods
106create_plugindb_file() {
107 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
108 local DB_FILE=${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}
109 insinto ${NEW_VDRPLUGINDB_DIR}
110 cat <<-EOT > ${D}/${DB_FILE}
111 VDRPLUGIN_DB=1
112 CREATOR=ECLASS
113 EBUILD=${CATEGORY}/${PN}
114 EBUILD_V=${PVR}
115 EOT
116}
117
118# Delete files created outside of vdr-plugin.eclass
119# vdrplugin-rebuild.ebuild converted plugindb and files are
120# not deleted by portage itself - should only be needed as
121# long as not every system has switched over to
122# vdrplugin-rebuild-0.2
123delete_orphan_plugindb_file() {
124 #elog Testing for orphaned plugindb file
125 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
126 local DB_FILE=${ROOT}/${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}
127
128 # file exists
129 [[ -f ${DB_FILE} ]] || return
130
131 # will portage handle the file itself
132 if grep -q CREATOR=ECLASS ${DB_FILE}; then
133 #elog file owned by eclass - don't touch it
134 return
135 fi
136
137 elog "Removing orphaned plugindb-file."
138 elog "\t#rm ${DB_FILE}"
139 rm ${DB_FILE}
140}
141
142
143create_header_checksum_file()
144{
145 # Danger: Not using $ROOT here, as compile will also not use it !!!
146 # If vdr in $ROOT and / differ, plugins will not run anyway
147
148 insinto ${VDR_CHECKSUM_DIR}
149 if [[ -f ${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then
150 newins ${VDR_CHECKSUM_DIR}/header-md5-vdr header-md5-${PN}
151 else
152 if type -p md5sum >/dev/null 2>&1; then
153 cd ${S}
154 (
155 cd ${VDR_INCLUDE_DIR}
156 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2
157 ) > header-md5-${PN}
158 doins header-md5-${PN}
159 fi
160 fi
161}
162
95vdr-plugin_pkg_setup() { 163vdr-plugin_pkg_setup() {
96 # -fPIC is needed for shared objects on some platforms (amd64 and others) 164 # -fPIC is needed for shared objects on some platforms (amd64 and others)
97 append-flags -fPIC 165 append-flags -fPIC
98 166
99 VDRVERSION=$(awk -F'"' '/VDRVERSION/ {print $2}' /usr/include/vdr/config.h) 167 # Where should the plugins live in the filesystem
168 VDR_PLUGIN_DIR="/usr/$(get_libdir)/vdr/plugins"
169 VDR_CHECKSUM_DIR="${VDR_PLUGIN_DIR%/plugins}/checksums"
170
171 # was /usr/lib/... some time ago
172 # since gentoo-vdr-scripts-0.3.6 it works with /usr/share/...
173 VDR_RC_DIR="/usr/share/vdr/rcscript"
174
175 # Pathes to includes
176 VDR_INCLUDE_DIR="/usr/include/vdr"
177 DVB_INCLUDE_DIR="/usr/include"
178
179
180 TMP_LOCALE_DIR="${WORKDIR}/tmp-locale"
181 LOCDIR="/usr/share/vdr/locale"
182 if has_version ">=media-video/vdr-1.5.7"; then
183 USE_GETTEXT=1
184 else
185 USE_GETTEXT=0
186 fi
187
188 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' ${VDR_INCLUDE_DIR}/config.h)
189 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' ${VDR_INCLUDE_DIR}/config.h)
190 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}"
191
100 einfo "Building ${PF} against vdr-${VDRVERSION}" 192 einfo "Building ${PF} against vdr-${VDRVERSION}"
193 einfo "APIVERSION: ${APIVERSION}"
101} 194}
102 195
103vdr-plugin_src_unpack() { 196vdr-plugin_src_unpack() {
197 if [[ -z ${VDR_INCLUDE_DIR} ]]; then
198 eerror "Wrong use of vdr-plugin.eclass."
199 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup."
200 echo
201 eerror "Please report this at bugs.gentoo.org."
202 die "vdr-plugin_pkg_setup not called!"
203 fi
104 [ -z "$1" ] && vdr-plugin_src_unpack unpack patchmakefile 204 [ -z "$1" ] && vdr-plugin_src_unpack unpack add_local_patch patchmakefile i18n
105 205
106 while [ "$1" ]; do 206 while [ "$1" ]; do
107 207
108 case "$1" in 208 case "$1" in
209 all_but_unpack)
210 vdr-plugin_src_unpack add_local_patch patchmakefile i18n
211 ;;
109 unpack) 212 unpack)
110 unpack ${A} 213 base_src_unpack
111 ;; 214 ;;
112 patchmakefile) 215 patchmakefile)
113 cd ${S} 216 if ! cd ${S}; then
217 ewarn "There seems to be no plugin-directory with the name ${S##*/}"
218 ewarn "Perhaps you find one among these:"
219 cd "${WORKDIR}"
220 ewarn "$(/bin/ls -1 ${WORKDIR})"
221 die "Could not change to plugin-source-directory!"
222 fi
114 223
115 ebegin "Patching Makefile" 224 einfo "Patching Makefile"
225 [[ -e Makefile ]] || die "Makefile of plugin can not be found!"
226 cp Makefile "${WORKDIR}"/Makefile.before
227
116 sed -i.orig Makefile \ 228 sed -i Makefile \
229 -e '1i\#Makefile was patched by vdr-plugin.eclass'
230
231 ebegin " Setting Pathes"
232 sed -i Makefile \
117 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \ 233 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
118 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \ 234 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
119 -e "s:^LIBDIR.*$:LIBDIR = ${S}:" \ 235 -e "s:^LIBDIR.*$:LIBDIR = ${S}:" \
120 -e "s:^TMPDIR.*$:TMPDIR = ${T}:" \ 236 -e "s:^TMPDIR.*$:TMPDIR = ${T}:" \
237 -e 's:-I$(VDRDIR)/include -I$(DVBDIR)/include:-I$(DVBDIR)/include -I$(VDRDIR)/include:' \
238 -e 's:-I$(VDRDIR)/include:-I'"${VDR_INCLUDE_DIR%vdr}"':' \
239 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):'
240 eend $?
241
242 ebegin " Converting to APIVERSION"
243 sed -i Makefile \
244 -e 's:^APIVERSION = :APIVERSION ?= :' \
245 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \
246 -e '2i\APIVERSION = '"${APIVERSION}"
247 eend $?
248
249 ebegin " Correcting Compile-Flags"
250 sed -i Makefile \
121 -e 's:^CXXFLAGS:#CXXFLAGS:' \ 251 -e 's:^CXXFLAGS:#CXXFLAGS:' \
122 -e 's:-I$(VDRDIR)/include:-I$(VDRDIR):' \ 252 -e '/LDFLAGS/!s:-shared:$(LDFLAGS) -shared:'
123 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
124 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):' \
125 -e 's:$(VDRDIR)/\([a-z]*\.h\|Make.config\):$(VDRDIR)/vdr/\1:'
126 eend $? 253 eend $?
254
255 ebegin " Disabling file stripping"
256 sed -i Makefile \
257 -e '/@.*strip/d' \
258 -e '/strip \$(LIBDIR)\/\$@/d' \
259 -e '/^STRIP =/d' \
260 -e '/@.*\$(STRIP)/d'
261 eend $?
262
263 # Use a file instead of an variable as single-stepping via ebuild
264 # destroys environment.
265 touch ${WORKDIR}/.vdr-plugin_makefile_patched
127 ;; 266 ;;
267 add_local_patch)
268 cd ${S}
269 if test -d "${VDR_LOCAL_PATCHES_DIR}/${PN}"; then
270 echo
271 einfo "Applying local patches"
272 for LOCALPATCH in ${VDR_LOCAL_PATCHES_DIR}/${PN}/${PV}/*.{diff,patch}; do
273 test -f "${LOCALPATCH}" && epatch "${LOCALPATCH}"
274 done
275 fi
276 ;;
277 i18n)
278 cd ${S}
279 if [[ ${USE_GETTEXT} = 0 ]]; then
280 # Remove i18n Target if using older vdr
281 sed -i Makefile \
282 -e '/^all:/s/ i18n//'
283 elif [[ ${USE_GETTEXT} = 1 && ! -d po && ${NO_GETTEXT_HACK} != 1 ]]; then
284 einfo "Converting translations to gettext"
285
286 local i18n_tool=/usr/share/vdr/bin/i18n-to-gettext.pl
287 if [[ ! -x ${i18n_tool} ]]; then
288 eerror "Missing ${i18n_tool}"
289 eerror "Please re-emerge vdr"
290 die "Missing ${i18n_tool}"
291 fi
292
293 # call i18n-to-gettext tool
294 # take all texts missing tr call into special file
295 ${i18n_tool} 2>/dev/null \
296 |sed -e '/^"/!d' \
297 -e '/^""$/d' \
298 -e 's/\(.*\)/trNOOP(\1)/' \
299 > dummy-translations-trNOOP.c
300
301 # if there were untranslated texts just run it again
302 # now the missing calls are listed in
303 # dummy-translations-trNOOP.c
304 if [[ -s dummy-translations-trNOOP.c ]]; then
305 ${i18n_tool} &>/dev/null
306 fi
307
308 # now use the modified Makefile
309 mv Makefile.new Makefile
310 fi
128 esac 311 esac
129 312
130 shift 313 shift
131 done 314 done
132} 315}
133 316
134vdr-plugin_copy_source_tree() { 317vdr-plugin_copy_source_tree() {
318 pushd . >/dev/null
135 cp -r ${S} ${T}/source-tree 319 cp -r ${S} ${T}/source-tree
136 cd ${T}/source-tree 320 cd ${T}/source-tree
137 mv Makefile.orig Makefile 321 cp "${WORKDIR}"/Makefile.before Makefile
138 sed -i Makefile \ 322 sed -i Makefile \
139 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \ 323 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
140 -e 's:^CXXFLAGS:#CXXFLAGS:' \ 324 -e 's:^CXXFLAGS:#CXXFLAGS:' \
141 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \ 325 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
142 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):' 326 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):'
327 popd >/dev/null
143} 328}
144 329
145vdr-plugin_install_source_tree() { 330vdr-plugin_install_source_tree() {
146 einfo "Installing sources" 331 einfo "Installing sources"
147 destdir=${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN} 332 destdir=${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN}
159 case "$1" in 344 case "$1" in
160 prepare) 345 prepare)
161 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree 346 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree
162 ;; 347 ;;
163 compile) 348 compile)
349 if [[ ! -f ${WORKDIR}/.vdr-plugin_makefile_patched ]]; then
350 eerror "Wrong use of vdr-plugin.eclass."
351 eerror "An ebuild for a vdr-plugin will not work without"
352 eerror "calling vdr-plugin_src_unpack to patch the Makefile."
353 echo
354 eerror "Please report this at bugs.gentoo.org."
355 die "vdr-plugin_src_unpack not called!"
356 fi
164 cd ${S} 357 cd ${S}
165 358
166 emake ${VDRPLUGIN_MAKE_TARGET:-all} || die "emake failed" 359 emake ${BUILD_PARAMS} \
360 ${VDRPLUGIN_MAKE_TARGET:-all} \
361 LOCALEDIR="${TMP_LOCALE_DIR}" \
362 || die "emake failed"
167 ;; 363 ;;
168 esac 364 esac
169 365
170 shift 366 shift
171 done 367 done
172} 368}
173 369
174vdr-plugin_src_install() { 370vdr-plugin_src_install() {
175 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_install_source_tree 371 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_install_source_tree
372 cd "${WORKDIR}"
373
374 if [[ -n ${VDR_MAINTAINER_MODE} ]]; then
375 local mname=${P}-Makefile
376 cp "${S}"/Makefile ${mname}.patched
377 cp Makefile.before ${mname}.before
378
379 diff -u ${mname}.before ${mname}.patched > ${mname}.diff
380
381 insinto "/usr/share/vdr/maintainer-data/makefile-changes"
382 doins ${mname}.diff
383
384 insinto "/usr/share/vdr/maintainer-data/makefile-before"
385 doins ${mname}.before
386
387 insinto "/usr/share/vdr/maintainer-data/makefile-patched"
388 doins ${mname}.patched
389
390 fi
391
176 cd ${S} 392 cd "${S}"
177
178 insinto "${VDR_PLUGIN_DIR}" 393 insinto "${VDR_PLUGIN_DIR}"
179 doins libvdr-*.so.* 394 doins libvdr-*.so.*
180 dodoc README* HISTORY CHANGELOG
181 395
182 for f in ${FILESDIR}/confd-${PV} ${FILESDIR}/confd; do 396 if [[ ${USE_GETTEXT} = 1 && -d ${TMP_LOCALE_DIR} ]]; then
183 if [[ -f "${f}" ]]; then 397 einfo "Installing locales"
184 insinto /etc/conf.d 398 cd "${TMP_LOCALE_DIR}"
185 newins "${f}" vdr.${VDRPLUGIN} 399 insinto "${LOCDIR}"
186 break 400 doins -r *
187 fi 401 fi
402
403 cd "${S}"
404 local docfile
405 for docfile in README* HISTORY CHANGELOG; do
406 [[ -f ${docfile} ]] && dodoc ${docfile}
188 done 407 done
189 408
190 for f in ${FILESDIR}/rc-addon-${PV}.sh ${FILESDIR}/rc-addon.sh; do 409 # if VDR_CONFD_FILE is empty and ${FILESDIR}/confd exists take it
191 if [[ -f "${f}" ]]; then 410 [[ -z ${VDR_CONFD_FILE} ]] && [[ -e ${FILESDIR}/confd ]] && VDR_CONFD_FILE=${FILESDIR}/confd
411
412 if [[ -n ${VDR_CONFD_FILE} ]]; then
413 newconfd "${VDR_CONFD_FILE}" vdr.${VDRPLUGIN}
414 fi
415
416
417 # if VDR_RCADDON_FILE is empty and ${FILESDIR}/rc-addon.sh exists take it
418 [[ -z ${VDR_RCADDON_FILE} ]] && [[ -e ${FILESDIR}/rc-addon.sh ]] && VDR_RCADDON_FILE=${FILESDIR}/rc-addon.sh
419
420 if [[ -n ${VDR_RCADDON_FILE} ]]; then
192 insinto "${VDR_RC_DIR}" 421 insinto "${VDR_RC_DIR}"
193 newins "${f}" plugin-${VDRPLUGIN}.sh 422 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh
194 break
195 fi 423 fi
196 done 424
425 create_header_checksum_file
426 create_plugindb_file
197} 427}
198 428
199vdr-plugin_pkg_postinst() { 429vdr-plugin_pkg_postinst() {
430 if has_version "<=media-tv/vdrplugin-rebuild-0.1"; then
200 update_vdrplugindb 431 update_vdrplugindb
201 einfo 432 fi
433 elog
202 einfo "The vdr plugin ${VDRPLUGIN} has now been installed." 434 elog "The vdr plugin ${VDRPLUGIN} has now been installed."
203 einfo "To activate execute the following command:" 435 elog "To activate execute the following command:"
204 einfo 436 elog
205 einfo " emerge --config ${PN}" 437 elog " emerge --config ${PN}"
206 einfo 438 elog
439 if [[ -n "${VDR_CONFD_FILE}" ]]; then
440 elog "And have a look at the config-file"
441 elog "/etc/conf.d/vdr.${VDRPLUGIN}"
442 elog
443 fi
207} 444}
208 445
209vdr-plugin_pkg_postrm() { 446vdr-plugin_pkg_postrm() {
447 if has_version "<=media-tv/vdrplugin-rebuild-0.1"; then
210 remove_vdrplugindb 448 remove_vdrplugindb
449 fi
450 delete_orphan_plugindb_file
211} 451}
212 452
213vdr-plugin_pkg_config_final() { 453vdr-plugin_pkg_config_final() {
214 diff ${conf_orig} ${conf} 454 diff ${conf_orig} ${conf}
215 rm ${conf_orig} 455 rm ${conf_orig}
216} 456}
217 457
218vdr-plugin_pkg_config() { 458vdr-plugin_pkg_config_old() {
459 elog "Using interface of gentoo-vdr-scripts-0.3.6 and older"
219 if [[ -z "${INSTALLPLUGIN}" ]]; then 460 if [[ -z "${INSTALLPLUGIN}" ]]; then
220 INSTALLPLUGIN="${VDRPLUGIN}" 461 INSTALLPLUGIN="${VDRPLUGIN}"
221 fi 462 fi
222 # First test if plugin is already inside PLUGINS 463 # First test if plugin is already inside PLUGINS
223 local conf=/etc/conf.d/vdr 464 local conf=/etc/conf.d/vdr
224 conf_orig=${conf}.before_emerge_config 465 conf_orig=${conf}.before_emerge_config
225 cp ${conf} ${conf_orig} 466 cp ${conf} ${conf_orig}
226 467
227 einfo "Reading ${conf}" 468 elog "Reading ${conf}"
228 if ! grep -q "^PLUGINS=" ${conf}; then 469 if ! grep -q "^PLUGINS=" ${conf}; then
229 local LINE=$(sed ${conf} -n -e '/^#.*PLUGINS=/=' | tail -n 1) 470 local LINE=$(sed ${conf} -n -e '/^#.*PLUGINS=/=' | tail -n 1)
230 if [[ -n "${LINE}" ]]; then 471 if [[ -n "${LINE}" ]]; then
231 sed -e ${LINE}'a PLUGINS=""' -i ${conf} 472 sed -e ${LINE}'a PLUGINS=""' -i ${conf}
232 else 473 else
245 break; 486 break;
246 fi 487 fi
247 done 488 done
248 489
249 if [[ "${active}" == "1" ]]; then 490 if [[ "${active}" == "1" ]]; then
250 einfo "${INSTALLPLUGIN} already activated" 491 elog "${INSTALLPLUGIN} already activated"
251 echo 492 echo
252 read -p "Do you want to deactivate ${INSTALLPLUGIN} (yes/no) " answer 493 read -p "Do you want to deactivate ${INSTALLPLUGIN} (yes/no) " answer
253 if [[ "${answer}" != "yes" ]]; then 494 if [[ "${answer}" != "yes" ]]; then
254 einfo "aborted" 495 elog "aborted"
255 return 496 return
256 fi 497 fi
257 einfo "Removing ${INSTALLPLUGIN} from active plugins." 498 elog "Removing ${INSTALLPLUGIN} from active plugins."
258 local LINE=$(sed ${conf} -n -e '/^PLUGINS=.*\<'${INSTALLPLUGIN}'\>/=' | tail -n 1) 499 local LINE=$(sed ${conf} -n -e '/^PLUGINS=.*\<'${INSTALLPLUGIN}'\>/=' | tail -n 1)
259 sed -i ${conf} -e ${LINE}'s/\<'${INSTALLPLUGIN}'\>//' \ 500 sed -i ${conf} -e ${LINE}'s/\<'${INSTALLPLUGIN}'\>//' \
260 -e ${LINE}'s/ \( \)*/ /g' \ 501 -e ${LINE}'s/ \( \)*/ /g' \
261 -e ${LINE}'s/ "/"/g' \ 502 -e ${LINE}'s/ "/"/g' \
262 -e ${LINE}'s/" /"/g' 503 -e ${LINE}'s/" /"/g'
264 vdr-plugin_pkg_config_final 505 vdr-plugin_pkg_config_final
265 return 506 return
266 fi 507 fi
267 508
268 509
269 einfo "Adding ${INSTALLPLUGIN} to active plugins." 510 elog "Adding ${INSTALLPLUGIN} to active plugins."
270 local LINE=$(sed ${conf} -n -e '/^PLUGINS=/=' | tail -n 1) 511 local LINE=$(sed ${conf} -n -e '/^PLUGINS=/=' | tail -n 1)
271 sed -i ${conf} -e ${LINE}'s/^PLUGINS=" *\(.*\)"/PLUGINS="\1 '${INSTALLPLUGIN}'"/' \ 512 sed -i ${conf} -e ${LINE}'s/^PLUGINS=" *\(.*\)"/PLUGINS="\1 '${INSTALLPLUGIN}'"/' \
272 -e ${LINE}'s/ \( \)*/ /g' \ 513 -e ${LINE}'s/ \( \)*/ /g' \
273 -e ${LINE}'s/ "/"/g' \ 514 -e ${LINE}'s/ "/"/g' \
274 -e ${LINE}'s/" /"/g' 515 -e ${LINE}'s/" /"/g'
275 516
276 vdr-plugin_pkg_config_final 517 vdr-plugin_pkg_config_final
277} 518}
278 519
520vdr-plugin_pkg_config_new() {
521 elog "Using interface introduced with gentoo-vdr-scripts-0.3.7"
522 if [[ -z "${INSTALLPLUGIN}" ]]; then
523 INSTALLPLUGIN="${VDRPLUGIN}"
524 fi
525
526 active=0
527 # First test if plugin is already inside PLUGINS
528 local conf=/etc/conf.d/vdr.plugins
529 exec 3<${conf}
530 while read -u 3 line; do
531 [[ ${line} == "" ]] && continue
532 [[ ${line:0:1} == "#" ]] && continue
533 set -- ${line}
534 [[ ${1} == ${INSTALLPLUGIN} ]] && active=1
535 done
536 exec 3<&-
537
538 if [[ $active == 0 ]]; then
539 elog "Adding ${INSTALLPLUGIN} to active plugins."
540
541 # The pure edit process.
542 echo "${INSTALLPLUGIN}" >> "${conf}"
543 else
544 elog "${INSTALLPLUGIN} already activated"
545 echo
546 read -p "Do you want to deactivate ${INSTALLPLUGIN} (yes/no) " answer
547 if [[ "${answer}" != "yes" ]]; then
548 elog "aborted"
549 return
550 fi
551 elog "Removing ${INSTALLPLUGIN} from active plugins."
552
553 # The pure edit process
554 sed -i "${conf}" -e "/^[[:space:]]*${INSTALLPLUGIN}[[:space:]]*\$/d"
555 fi
556}
557
558vdr-plugin_pkg_config() {
559 if has_version ">media-tv/gentoo-vdr-scripts-0.3.6"; then
560 vdr-plugin_pkg_config_new
561 else
562 vdr-plugin_pkg_config_old
563 fi
564}
565
566fix_vdr_libsi_include()
567{
568 einfo "Fixing include of libsi-headers"
569 local f
570 for f; do
571 sed -i "${f}" \
572 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \
573 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:'
574 done
575}
576
279EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config 577EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config

Legend:
Removed from v.1.11  
changed lines
  Added in v.1.49

  ViewVC Help
Powered by ViewVC 1.1.20